## DMS Set Firmware Preference request DMS Set Firmware Preference request |

## Functions

QmiMessageDmsSetFirmwarePreferenceInput * | qmi_message_dms_set_firmware_preference_input_new ()
QmiMessageDmsSetFirmwarePreferenceInput * | qmi_message_dms_set_firmware_preference_input_ref ()
void | qmi_message_dms_set_firmware_preference_input_unref ()
gboolean | qmi_message_dms_set_firmware_preference_input_get_modem_storage_index ()
gboolean | qmi_message_dms_set_firmware_preference_input_set_modem_storage_index ()
gboolean | qmi_message_dms_set_firmware_preference_input_get_download_override ()
gboolean | qmi_message_dms_set_firmware_preference_input_set_download_override ()
gboolean | qmi_message_dms_set_firmware_preference_input_get_list ()
gboolean | qmi_message_dms_set_firmware_preference_input_set_list ()
QmiMessageDmsSetFirmwarePreferenceOutput * | qmi_message_dms_set_firmware_preference_output_ref ()
void | qmi_message_dms_set_firmware_preference_output_unref ()
gboolean | qmi_message_dms_set_firmware_preference_output_get_result ()
gboolean | qmi_message_dms_set_firmware_preference_output_get_image_download_list ()
void | qmi_client_dms_set_firmware_preference ()
QmiMessageDmsSetFirmwarePreferenceOutput * | qmi_client_dms_set_firmware_preference_finish ()

## Types and Values

| QmiMessageDmsSetFirmwarePreferenceInput
| QmiMessageDmsSetFirmwarePreferenceInputListImage
| QmiMessageDmsSetFirmwarePreferenceOutput

## Object Hierarchy

        GBoxed
        ├── QmiMessageDmsSetFirmwarePreferenceInput
        ╰── QmiMessageDmsSetFirmwarePreferenceOutput

## Description

## Functions

### qmi_message_dms_set_firmware_preference_input_new ()

    QmiMessageDmsSetFirmwarePreferenceInput *
    qmi_message_dms_set_firmware_preference_input_new
                                   (void);

Allocates a new QmiMessageDmsSetFirmwarePreferenceInput.

#### Returns

the newly created QmiMessageDmsSetFirmwarePreferenceInput. The returned value should be freed with `qmi_message_dms_set_firmware_preference_input_unref()`.

Since: 1.0

### qmi_message_dms_set_firmware_preference_input_ref ()

    QmiMessageDmsSetFirmwarePreferenceInput *
    qmi_message_dms_set_firmware_preference_input_ref
                                   (QmiMessageDmsSetFirmwarePreferenceInput *self);

Atomically increments the reference count of `self` by one.

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceInput. |

#### Returns

the new reference to `self` .

Since: 1.0

### qmi_message_dms_set_firmware_preference_input_unref ()

    void
    qmi_message_dms_set_firmware_preference_input_unref
                                   (QmiMessageDmsSetFirmwarePreferenceInput *self);

Atomically decrements the reference count of `self` by one. If the reference count drops to 0, `self` is completely disposed.

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceInput. |

Since: 1.0

### qmi_message_dms_set_firmware_preference_input_get_modem_storage_index ()

    gboolean
    qmi_message_dms_set_firmware_preference_input_get_modem_storage_index
                                   (QmiMessageDmsSetFirmwarePreferenceInput *self,
                                    guint8 *value_modem_storage_index,
                                    GError **error);

Get the 'Modem Storage Index' field from `self` .

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceInput. |
value_modem_storage_index | a placeholder for the output guint8, or `NULL` if not required. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the field is found, `FALSE` otherwise.

Since: 1.0

### qmi_message_dms_set_firmware_preference_input_set_modem_storage_index ()

    gboolean
    qmi_message_dms_set_firmware_preference_input_set_modem_storage_index
                                   (QmiMessageDmsSetFirmwarePreferenceInput *self,
                                    guint8 value_modem_storage_index,
                                    GError **error);

Set the 'Modem Storage Index' field in the message.

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceInput. |
value_modem_storage_index | a guint8. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if `value` was successfully set, `FALSE` otherwise.

Since: 1.0

### qmi_message_dms_set_firmware_preference_input_get_download_override ()

    gboolean
    qmi_message_dms_set_firmware_preference_input_get_download_override
                                   (QmiMessageDmsSetFirmwarePreferenceInput *self,
                                    gboolean *value_download_override,
                                    GError **error);

Get the 'Download Override' field from `self` .

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceInput. |
value_download_override | a placeholder for the output gboolean, or `NULL` if not required. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the field is found, `FALSE` otherwise.

Since: 1.0

### qmi_message_dms_set_firmware_preference_input_set_download_override ()

    gboolean
    qmi_message_dms_set_firmware_preference_input_set_download_override
                                   (QmiMessageDmsSetFirmwarePreferenceInput *self,
                                    gboolean value_download_override,
                                    GError **error);

Set the 'Download Override' field in the message.

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceInput. |
value_download_override | a gboolean. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if `value` was successfully set, `FALSE` otherwise.

Since: 1.0

### qmi_message_dms_set_firmware_preference_input_get_list ()

    gboolean
    qmi_message_dms_set_firmware_preference_input_get_list
                                   (QmiMessageDmsSetFirmwarePreferenceInput *self,
                                    GArray **value_list,
                                    GError **error);

Get the 'List' field from `self` .

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceInput. |
value_list | a placeholder for the output GArray of QmiMessageDmsSetFirmwarePreferenceInputListImage elements, or `NULL` if not required. Do not free it, it is owned by `self` . |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the field is found, `FALSE` otherwise.

Since: 1.0

### qmi_message_dms_set_firmware_preference_input_set_list ()

    gboolean
    qmi_message_dms_set_firmware_preference_input_set_list
                                   (QmiMessageDmsSetFirmwarePreferenceInput *self,
                                    GArray *value_list,
                                    GError **error);

Set the 'List' field in the message.

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceInput. |
value_list | a GArray of QmiMessageDmsSetFirmwarePreferenceInputListImage elements. A new reference to `value_list` will be taken. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if `value` was successfully set, `FALSE` otherwise.

Since: 1.0

### qmi_message_dms_set_firmware_preference_output_ref ()

    QmiMessageDmsSetFirmwarePreferenceOutput *
    qmi_message_dms_set_firmware_preference_output_ref
                                   (QmiMessageDmsSetFirmwarePreferenceOutput *self);

Atomically increments the reference count of `self` by one.

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceOutput. |

#### Returns

the new reference to `self` .

Since: 1.0

### qmi_message_dms_set_firmware_preference_output_unref ()

    void
    qmi_message_dms_set_firmware_preference_output_unref
                                   (QmiMessageDmsSetFirmwarePreferenceOutput *self);

Atomically decrements the reference count of `self` by one. If the reference count drops to 0, `self` is completely disposed.

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceOutput. |

Since: 1.0

### qmi_message_dms_set_firmware_preference_output_get_result ()

    gboolean
    qmi_message_dms_set_firmware_preference_output_get_result
                                   (QmiMessageDmsSetFirmwarePreferenceOutput *self,
                                    GError **error);

Get the result of the QMI operation.

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceOutput. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the QMI operation succeeded, `FALSE` if `error` is set.

Since: 1.0

### qmi_message_dms_set_firmware_preference_output_get_image_download_list ()

    gboolean
    qmi_message_dms_set_firmware_preference_output_get_image_download_list
                                   (QmiMessageDmsSetFirmwarePreferenceOutput *self,
                                    GArray **value_image_download_list,
                                    GError **error);

Get the 'Image Download List' field from `self` .

#### Parameters

self | a QmiMessageDmsSetFirmwarePreferenceOutput. |
value_image_download_list | a placeholder for the output GArray of QmiDmsFirmwareImageType elements, or `NULL` if not required. Do not free it, it is owned by `self` . |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the field is found, `FALSE` otherwise.

Since: 1.0

### qmi_client_dms_set_firmware_preference ()

    void
    qmi_client_dms_set_firmware_preference
                                   (QmiClientDms *self,
                                    QmiMessageDmsSetFirmwarePreferenceInput *input,
                                    guint timeout,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously sends a Set Firmware Preference request to the device.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from.

You can then call `qmi_client_dms_set_firmware_preference_finish()` to get the result of the operation.

#### Parameters

self | a QmiClientDms. |
input | a QmiMessageDmsSetFirmwarePreferenceInput. |
timeout | maximum time to wait for the method to complete, in seconds. |
cancellable | a GCancellable or `NULL`. |
callback | a GAsyncReadyCallback to call when the request is satisfied. |
user_data | user data to pass to `callback` . |

Since: 1.0

### qmi_client_dms_set_firmware_preference_finish ()

    QmiMessageDmsSetFirmwarePreferenceOutput *
    qmi_client_dms_set_firmware_preference_finish
                                   (QmiClientDms *self,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an async operation started with `qmi_client_dms_set_firmware_preference()`.

#### Parameters

self | a QmiClientDms. |
res | the GAsyncResult obtained from the GAsyncReadyCallback passed to `qmi_client_dms_set_firmware_preference()`. |
error | Return location for error or `NULL`. |

#### Returns

a QmiMessageDmsSetFirmwarePreferenceOutput, or `NULL` if `error` is set. The returned value should be freed with `qmi_message_dms_set_firmware_preference_output_unref()`.

Since: 1.0

## Types and Values

### QmiMessageDmsSetFirmwarePreferenceInput

    typedef struct _QmiMessageDmsSetFirmwarePreferenceInput QmiMessageDmsSetFirmwarePreferenceInput;

The QmiMessageDmsSetFirmwarePreferenceInput structure contains private data and should only be accessed using the provided API.

Since: 1.0

### QmiMessageDmsSetFirmwarePreferenceInputListImage

    typedef struct {
        QmiDmsFirmwareImageType type;
        GArray *unique_id;
        gchar *build_id;
    } QmiMessageDmsSetFirmwarePreferenceInputListImage;

A QmiMessageDmsSetFirmwarePreferenceInputListImage struct.

#### Members

QmiDmsFirmwareImageType `type`; | a QmiDmsFirmwareImageType. |
GArray *`unique_id`; | a GArray of guint8 elements. |
gchar *`build_id`; | a string. |

Since: 1.0

### QmiMessageDmsSetFirmwarePreferenceOutput

    typedef struct _QmiMessageDmsSetFirmwarePreferenceOutput QmiMessageDmsSetFirmwarePreferenceOutput;

The QmiMessageDmsSetFirmwarePreferenceOutput structure contains private data and should only be accessed using the provided API.

Since: 1.0